<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BestPracticeRecord StructType
 * @subpackage Structs
 */
class BestPracticeRecord extends AbstractStructBase
{
    /**
     * The Score
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Score;
    /**
     * The MatrixName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MatrixName;
    /**
     * Constructor method for BestPracticeRecord
     * @uses BestPracticeRecord::setScore()
     * @uses BestPracticeRecord::setMatrixName()
     * @param bool $score
     * @param string $matrixName
     */
    public function __construct($score = null, $matrixName = null)
    {
        $this
            ->setScore($score)
            ->setMatrixName($matrixName);
    }
    /**
     * Get Score value
     * @return bool
     */
    public function getScore()
    {
        return $this->Score;
    }
    /**
     * Set Score value
     * @param bool $score
     * @return \CustomerManagement\StructType\BestPracticeRecord
     */
    public function setScore($score = null)
    {
        // validation for constraint: boolean
        if (!is_null($score) && !is_bool($score)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($score, true), gettype($score)), __LINE__);
        }
        $this->Score = $score;
        return $this;
    }
    /**
     * Get MatrixName value
     * @return string|null
     */
    public function getMatrixName()
    {
        return $this->MatrixName;
    }
    /**
     * Set MatrixName value
     * @param string $matrixName
     * @return \CustomerManagement\StructType\BestPracticeRecord
     */
    public function setMatrixName($matrixName = null)
    {
        // validation for constraint: string
        if (!is_null($matrixName) && !is_string($matrixName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matrixName, true), gettype($matrixName)), __LINE__);
        }
        $this->MatrixName = $matrixName;
        return $this;
    }
}
